//Create a class for door control device
package DoorControl
import Timer.SimulatedTimer

public class DoorControls {
	int deviceNumbers	
	List doorControls
	def timers
	def sendEvent

	//If we have only one device
	private String id = "DoorControlID0"
	private String label = "DoorControl0"
	private String displayName = "DoorControl0"
	private String doorState = "closed"
	private String doorLatestValue = "closed"

	DoorControls(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent
		this.timers = new SimulatedTimer()
		this.deviceNumbers = deviceNumbers
		this.doorControls = []
		
		doorControls.add(new DoorControl(sendEvent, id, label, displayName, this.doorState, this.doorLatestValue))
	}

	//Methods for closures
	def count(Closure Input) {
		doorControls.count(Input)
	}
	def size() {
		doorControls.size()
	}
	def each(Closure Input) {
		doorControls.each(Input)
	}
	def find(Closure Input) {
		doorControls.find(Input)
	}
	def collect(Closure Input) {
		doorControls.collect(Input)
	}

	//By Apps
	def open() {
		doorControls[0].on()
	}

	def open(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			doorControls[0].on()
		}
	}

	def close() {
		doorControls[0].off()
	}

	def close(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			doorControls[0].off()
		}
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		doorControls[0].setValue(eventDataMap["value"])
		this.doorState = doorControls[0].doorState
		sendEvent(eventDataMap)
	}


	def currentValue(String deviceFeature) {
		doorControls[0].currentValue(deviceFeature)
	}

	def latestValue(String deviceFeature) {
		doorControls[0].latestValue(deviceFeature)
	}

	def getAt(int ix) {
		doorControls[ix]
	}
}
