import os
readyToReturn = 0
ToReturn = ""
eventMap = []
app1Capabilities = []
app2Capabilities = []

def GetToken(f):
	global readyToReturn
	global ToReturn
	Skip = ['\n', '\t', ' ']
	Special = ["(", "\"", ":", ",", "{", "}", ")", "/", "*"]
	S = ""
	if (readyToReturn):
		readyToReturn = 0
		return ToReturn
	ToReturn = ""
	c = f.read(1)
	while(True):
		if (c in Special):
			if (S != ""):
				readyToReturn = 1
				ToReturn = c
				return S
			else:
				return c
		elif (c in Skip):
			if (S != ""):
				return S	
			else:
				c = f.read(1)
				continue
		S += c
		c = f.read(1)
		if not c:
			return "EOF"

def ExtractFunctions(F, appName):
	global eventMap
	Temp = GetToken(F)
	while (Temp != "EOF"):
		if (Temp == "def" or Temp == "private"):
			Temp = GetToken(F)
			NameofFunc = Temp
			if (GetToken(F) != "="): #We have a function to create object for
				if (appName == "App1"):
					extractedFunctionsApp1.write("//Global Object for functions in subscribe method!\n")	
					extractedFunctionsApp1.write("def %s = this.&" % NameofFunc)
					extractedFunctionsApp1.write("%s\n" % NameofFunc)
				else:
					extractedFunctionsApp2.write("//Global Object for functions in subscribe method!\n")	
					extractedFunctionsApp2.write("def %s = this.&" % NameofFunc)
					extractedFunctionsApp2.write("%s\n" % NameofFunc)
		
		#Check subscribed events
		if (Temp == "subscribe"):
			counter = 0
			while (counter < 5 and Temp != "\""):
				Temp = GetToken(F)
				counter = counter + 1
			Temp = GetToken(F)
			#If counter >= 5 that means it is not found, so it must be appTouch
			if (counter >= 5):
				Temp = "Touched"
			if Temp not in eventMap:
				eventMap.append(Temp)

		#Check and analyze capabilities for physical interaction
		AnalyzeCapabilities(Temp, appName)

		Temp = GetToken(F)
	
	#Warn if there is a potential for physical interaction
	AnalyzePhysicalInteraction(app1Capabilities, app2Capabilities)
	AnalyzePhysicalInteraction(app2Capabilities, app1Capabilities)

		

def AnalyzeCapabilities(Temp, appName):
			#Illuminance related
	if (Temp == "capability.switch" or
			Temp == "capability.switchLevel" or
			Temp == "capability.illuminanceMeasurement" or
			#Motion related
			Temp == "capability.motionSensor" or
			#Water related
			Temp == "capability.valve" or
			Temp == "capability.waterSensor" or
			#Sound related
			Temp == "capability.musicPlayer" or
			Temp == "capability.alarm" or
			Temp == "capability.speechSynthesis" or
			Temp == "capability.soundSensor"):
		if (appName == "App1"):
			app1Capabilities.append(Temp)
		else:
			app2Capabilities.append(Temp)
			
def AnalyzePhysicalInteraction(app1Capab, app2Capab):
	#Light
	if ("capability.illuminanceMeasurement" in app1Capab) and ("capability.switch" in app2Capab or 
			"capability.switchLevel" in app2Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (light) detected between App1 and App2!\n")
	#Motion
	if ("capability.motionSensor" in app1Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (motion) detected between App1 and App2!\n")		
	#Water
	if ("capability.waterSensor" in app1Capab) and ("capability.valve" in app2Capab or 
			"capability.switch" in app2Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (water) detected between App1 and App2!\n")
	#Sound
	if ("capability.soundSensor" in app1Capab) and ("capability.musicPlayer" in app2Capab or 
			"capability.alarm" in app2Capab or "capability.speechSynthesis" in app2Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (sound) detected between App1 and App2!\n")

def ExtractEvents(extractedEvents):
	global eventMap
	extractedEvents.write("Random random = new Random(42)\n")
	extractedEvents.write("counter = 1000\n")
	extractedEvents.write("while(counter > 0) {\n")
	extractedEvents.write("\tdef eventNumber = random.nextInt(%d)\n" % (len(eventMap) - 1))
	extractedEvents.write("\tswitch(eventNumber) {\n")
	eventCounter = 0;
	for i in range(len(eventMap)):
		extractedEvents.write("\t\tcase %d:\n" % eventCounter)
		if eventMap[i] == "lock":
			event = open("eventSimulator/lockEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "unlock":
			event = open("eventSimulator/unlockEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "contact.open":
			event = open("eventSimulator/contactOpenEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "contact.closed":
			event = open("eventSimulator/contactClosedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "nfcTouch":
			event = open("eventSimulator/nfcTouchEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "Touched":
			event = open("eventSimulator/appTouchEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "button":
			#Write two events subsequently
			event = open("eventSimulator/buttonPushedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/buttonHeldEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "presence":
			#Write two events subsequently
			event = open("eventSimulator/presencePresentEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/presenceLeftEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "doorState":
			#Write two events subsequently
			event = open("eventSimulator/doorOpenEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/doorClosedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "motion":
			#Write two events subsequently
			event = open("eventSimulator/motionActiveEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/motionInactiveEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "smoke":
			#Write three events subsequently
			event = open("eventSimulator/smokeClearEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/smokeDetectedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/smokeTestedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "carbonMonoxide":
			#Write three events subsequently
			event = open("eventSimulator/carbonMonoxideClearEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/carbonMonoxideDetectedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/carbonMonoxideTestedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "battery":
			event = open("eventSimulator/batteryChargeEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "thermostatMode":
			#Write five events subsequently
			event = open("eventSimulator/thermostatAutoModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/thermostatCoolModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/thermostatEmergencyHeatModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/thermostatHeatModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/thermostatOffModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "switch":
			#Write two events subsequently
			event = open("eventSimulator/switchOnEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/switchOffEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventMap[i] == "Location":
			#Write three events subsequently
			event = open("eventSimulator/locationHomeEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/locationAwayEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			extractedEvents.write("\t\t\tbreak\n")
			eventCounter = eventCounter + 1
			extractedEvents.write("\t\tcase %d:\n" % eventCounter)
			event = open("eventSimulator/locationNightEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		eventCounter = eventCounter + 1

		###TODO: Add more events later
		extractedEvents.write("\n\t\t\tbreak\n")
	extractedEvents.write("\t}\n")
	extractedEvents.write("\tcounter--\n")
	extractedEvents.write("}\n")
		
#Extract objects to call functions from App1
F1 = open("Extractor/App1/App1.groovy", "r")
extractedFunctionsApp1 = open("Extractor/App1/extractedFunctionsApp1.groovy", "w+")
ExtractFunctions(F1, "App1")
F1.close()

#Extract objects to call functions from App2
F2 = open("Extractor/App2/App2.groovy", "r")
extractedFunctionsApp2 = open("Extractor/App2/extractedFunctionsApp2.groovy", "w+")
ExtractFunctions(F2, "App2")
F2.close()

#Prepare eventSimulator file while parsing the App1 and App2 files
extractedEvents = open("eventSimulator/eventSimulator.groovy", "w+")
ExtractEvents(extractedEvents)
extractedEvents.close()

#Save the extracted methods and app1 in a same file to extract information
extractorFile = open("Extractor/extractorFile.groovy", "w+")
Extractor = open("Extractor/Extractor.groovy", "r")
F1 = open("Extractor/App1/App1.groovy", "r")

extractorFile.write("////////////////////\n")
extractorFile.write("@Field App\n")
extractorFile.write("App = \"App1\"")
extractorFile.write("\n")
for line in Extractor:
	extractorFile.write(line)
extractorFile.write("\n\n")
for line in F1:
	extractorFile.write(line)
extractorFile.close()
Extractor.close()
F1.close()
#Run the file to extract the objects
os.system("groovy Extractor/extractorFile.groovy")


#Save the extracted methods and app2 in a same file to extract information
extractorFile = open("Extractor/extractorFile.groovy", "w+")
Extractor = open("Extractor/Extractor.groovy", "r")
F2 = open("Extractor/App2/App2.groovy", "r")

extractorFile.write("////////////////////\n")
extractorFile.write("@Field App\n")
extractorFile.write("App = \"App2\"")
extractorFile.write("\n")
for line in Extractor:
	extractorFile.write(line)
extractorFile.write("\n\n")
for line in F2:
	extractorFile.write(line)
#Run the file to extract the objects
extractorFile.close()
Extractor.close()
F2.close()
os.system("groovy Extractor/extractorFile.groovy")




