//Create a class for presence sensor
package PresenceSensor
import Timer.SimulatedTimer

public class PresenceSensors {
	private int deviceNumbers
	private List presenceSensors
	def sendEvent

	//For one device(We cannot have obj.id)-> We should have obj[0].id
	private String id = "presenceSensorID0"
	private String label = "presenceSensor0"
	private String displayName = "presenceSensor0"
	private String presenceState = "not present"
	private String currentPresence = "not present"
	private String presenceLatestValue = "not present"

		
	PresenceSensors(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent		
		this.deviceNumbers = deviceNumbers
		this.presenceSensors = []

		presenceSensors.add(new PresenceSensor(id, label, displayName, this.presenceState, this.presenceLatestValue))
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		presenceSensors[0].setValue(eventDataMap["value"])
		if (deviceNumbers == 1)
			this.presenceLatestValue = presenceSensors[0].presenceLatestValue
			this.presenceState = presenceSensors[0].presenceState
			this.currentPresence = presenceSensors[0].presenceState
		sendEvent(eventDataMap)
	}

	//Methods for closures
	def count(Closure Input) {
		presenceSensors.count(Input)
	}
	def size() {
		presenceSensors.size()
	}
	def each(Closure Input) {
		presenceSensors.each(Input)
	}
	def find(Closure Input) {
		presenceSensors.find(Input)
	}
	def collect(Closure Input) {
		presenceSensors.collect(Input)
	}


	def currentValue(String deviceFeature) {
		presenceSensors[0].currentValue(deviceFeature)//It is called if we have only one device
	}

	def latestValue(String deviceFeature) {
		presenceSensors[0].latestValue(deviceFeature)//It is called if we have only one device
	}

	def getAt(int ix) {
		presenceSensors[ix]
	}
}
