//Create a class for thermostat device
package Thermostat
import Timer.SimulatedTimer

public class Thermostat {
	private String id
	private String label
	private String displayName
	private int temperature
	private int currentCoolingSetpoint
	private int currentHeatingSetpoint
	private int coolingSetpoint
	private int thermostatSetpoint
	private int heatingSetpoint
	private List coolingSetpointRange
	private List thermostatSetpointRange
	private List heatingSetpointRange
	private List supportedThermostatFanModes
	private List supportedThermostatModes
	private String thermostatOperatingState
	private String thermostatFanMode
	private String thermostatMode
	def sendEvent
	def timers


	Thermostat(Closure sendEvent, String id, String label, String displayName, int temperature, int currentCoolingSetpoint, int currentHeatingSetpoint, int coolingSetpoint, 
                   int thermostatSetpoint, int heatingSetpoint, List coolingSetpointRange, List thermostatSetpointRange, List heatingSetpointRange, 
                   List supportedThermostatFanModes, List supportedThermostatModes, String thermostatOperatingState, String thermostatFanMode, String thermostatMode) {
		this.id = id
		this.label = label
		this.sendEvent = sendEvent
		this.temperature = temperature
		this.currentCoolingSetpoint = currentCoolingSetpoint
		this.currentHeatingSetpoint = currentHeatingSetpoint
		this.coolingSetpoint = coolingSetpoint
		this.thermostatSetpoint = thermostatSetpoint
		this.heatingSetpoint = heatingSetpoint
		this.coolingSetpointRange = coolingSetpointRange
		this.thermostatSetpointRange = thermostatSetpointRange
		this.heatingSetpointRange = heatingSetpointRange
		this.supportedThermostatFanModes = supportedThermostatFanModes
		this.supportedThermostatModes = supportedThermostatModes
		this.thermostatOperatingState = thermostatOperatingState
		this.thermostatFanMode = thermostatFanMode
		this.thermostatMode = thermostatMode
	}


	//By Apps
	def setCoolingSetpoint(int coolingSetpoint) {
		this.coolingSetpoint = coolingSetpoint
		this.currentCoolingSetpoint = currentCoolingSetpoint
		println("Cooling set point for the thermostat with id:$id is changed to $coolingSetpoint!")
	}

	def setHeatingSetpoint(int heatingSetpoint) {
		this.heatingSetpoint = heatingSetpoint
		this.currentHeatingSetpoint = currentHeatingSetpoint
		println("Heating set point for the thermostat with id:$id is changed to $heatingSetpoint!")
	}

	def setSchedule() {
		//Not implemented yet
	}

	def setThermostatFanMode(String thermostatFanMode) {
		this.thermostatFanMode = thermostatFanMode
		println("Fan mode of the thermostat with id:$id is changed to $thermostatFanMode!")
	}

	def setThermostatMode(String thermostatMode) {
		this.thermostatMode = thermostatMode
		println("Mode of the thermostat with id:$id is changed to $thermostatMode!")
	}


	//By Model Checker
	/*def setValue(String value) {
		println("the door with id:$id is $value!")
		this.lockLatestValue = this.lockState
		this.lockState = value
		this.currentLock = value
	}*/
}
